﻿using System;
using System.Collections.Generic;

using System.Text;

using System.Windows.Data;

namespace WPF_Editors
{
    class ValueToDisplayTextConverter :IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            //Motified code to use with MaskedEditor which is passing string value. 
            if ( targetType == typeof(string))
            {
                if (value is Decimal)
                    return Convt(value.ToString());
                else if (value is String)
                    return Convt((string)value);
            }            

            return String.Empty;             
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
             throw new NotImplementedException(); 
        }

        private string Convt(string text)
        {
            //This forces to text to be empty if the value is 0, which is the initial value.
            if (text =="0.000000") return "";

            //This code is inserting commas into the string.
            string result = text;           
            string zeroes = "000000";
            string[] tmp = new string[2];
            int numLength = 0;
           
            string rString = "";

            if (text.Contains("."))
            {
                tmp = text.Split(new char[1] { '.' }, 2);
                numLength = tmp[0].Length;              
                rString = tmp[0];              
               
                for (int i=numLength-3; i > 0; i-=3 )
                {
                    rString = rString.Insert(i, ",");
                }                

                result = rString + "." + tmp[1] + zeroes.Substring(0,(6-tmp[1].Length) );
               
            }
            return result;
        }
    }
}
